/**
 */
package org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.LifeCycleHierarchyFactory
 * @model kind="package"
 * @generated
 */
public interface LifeCycleHierarchyPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "LifeCycleHierarchy";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///RAMI40/LifeCycleHierarchy.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "RAMI40.LifeCycleHierarchy";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	LifeCycleHierarchyPackage eINSTANCE = org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl.LifeCycleHierarchyPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl._2InstanceProductionImpl <em>2Instance Production</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl._2InstanceProductionImpl
	 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl.LifeCycleHierarchyPackageImpl#get_2InstanceProduction()
	 * @generated
	 */
	int _2INSTANCE_PRODUCTION = 0;

	/**
	 * The feature id for the '<em><b>Base Package</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int _2INSTANCE_PRODUCTION__BASE_PACKAGE = 0;

	/**
	 * The number of structural features of the '<em>2Instance Production</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int _2INSTANCE_PRODUCTION_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>2Instance Production</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int _2INSTANCE_PRODUCTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl._1TypeDevelopmentImpl <em>1Type Development</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl._1TypeDevelopmentImpl
	 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl.LifeCycleHierarchyPackageImpl#get_1TypeDevelopment()
	 * @generated
	 */
	int _1TYPE_DEVELOPMENT = 1;

	/**
	 * The feature id for the '<em><b>Base Package</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int _1TYPE_DEVELOPMENT__BASE_PACKAGE = 0;

	/**
	 * The number of structural features of the '<em>1Type Development</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int _1TYPE_DEVELOPMENT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>1Type Development</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int _1TYPE_DEVELOPMENT_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy._2InstanceProduction <em>2Instance Production</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>2Instance Production</em>'.
	 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy._2InstanceProduction
	 * @generated
	 */
	EClass get_2InstanceProduction();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy._2InstanceProduction#getBase_Package <em>Base Package</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Base Package</em>'.
	 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy._2InstanceProduction#getBase_Package()
	 * @see #get_2InstanceProduction()
	 * @generated
	 */
	EReference get_2InstanceProduction_Base_Package();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy._1TypeDevelopment <em>1Type Development</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>1Type Development</em>'.
	 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy._1TypeDevelopment
	 * @generated
	 */
	EClass get_1TypeDevelopment();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy._1TypeDevelopment#getBase_Package <em>Base Package</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Base Package</em>'.
	 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy._1TypeDevelopment#getBase_Package()
	 * @see #get_1TypeDevelopment()
	 * @generated
	 */
	EReference get_1TypeDevelopment_Base_Package();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	LifeCycleHierarchyFactory getLifeCycleHierarchyFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl._2InstanceProductionImpl <em>2Instance Production</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl._2InstanceProductionImpl
		 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl.LifeCycleHierarchyPackageImpl#get_2InstanceProduction()
		 * @generated
		 */
		EClass _2INSTANCE_PRODUCTION = eINSTANCE.get_2InstanceProduction();

		/**
		 * The meta object literal for the '<em><b>Base Package</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference _2INSTANCE_PRODUCTION__BASE_PACKAGE = eINSTANCE.get_2InstanceProduction_Base_Package();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl._1TypeDevelopmentImpl <em>1Type Development</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl._1TypeDevelopmentImpl
		 * @see org.eclipse.papyrus.manufacturing.RAMI40.LifeCycleHierarchy.impl.LifeCycleHierarchyPackageImpl#get_1TypeDevelopment()
		 * @generated
		 */
		EClass _1TYPE_DEVELOPMENT = eINSTANCE.get_1TypeDevelopment();

		/**
		 * The meta object literal for the '<em><b>Base Package</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference _1TYPE_DEVELOPMENT__BASE_PACKAGE = eINSTANCE.get_1TypeDevelopment_Base_Package();

	}

} //LifeCycleHierarchyPackage
